@echo off

cd /d %~dp0

echo %DATE%_%TIME%	Delete task ... >> log.txt
SchTasks /Delete /TN "TB3 FW Upgrade Part2" /F >> log.txt 2>&1
echo %DATE%_%TIME%	Done, rc=%ERRORLEVEL% >> log.txt

echo %DATE%_%TIME%	Show power message >> log.txt
START /WAIT ShowMsg.exe

echo %DATE%_%TIME%	Check power status ... >> log.txt
WMIC Path Win32_Battery Get BatteryStatus | find "2" >> log.txt 2>&1
IF %ERRORLEVEL% EQU 0 (
	echo %DATE%_%TIME%	Done, AC power >> log.txt
	GOTO INIT_CONTROLLER
) ELSE (
	echo %DATE%_%TIME%	Done, DC power >> log.txt
	exit /B 1
)


:INIT_CONTROLLER
echo Initialize controller ...
echo %DATE%_%TIME%	Initialize controller ... >> log.txt
timeout 3
echo %DATE%_%TIME%	Force power ... >> log.txt
START /B /WAIT ControllerForcePower.exe 1 >> log.txt 2>&1
echo %DATE%_%TIME%	Done >> log.txt
timeout 10
echo %DATE%_%TIME%	Enumerate controllers ... >> log.txt
START /B /WAIT FwUpdateCmd.exe enumcontrollers > controller.txt
set /p controller= <controller.txt
find /i controller.txt "Error" 
if "%errorlevel%" == "0" (
	echo %DATE%_%TIME%	Failed to enumerate controllers. Retry >> log.txt
	goto INIT_CONTROLLER
)
echo %DATE%_%TIME%	Done >> log.txt


:CHECK_VERSION
echo Check version ...
echo %DATE%_%TIME%	Check version ... >> log.txt
START /B /WAIT FwUpdateCmd.exe GetCurrentNvmVersion "%controller%" > nvm_version.txt
set /p version= <nvm_version.txt
IF %version% GEQ 15 (
	echo Your Thunderbolt firmware version is newer. You don't need to update it.
	echo %DATE%_%TIME%	Done, version=%version%, don't need upgrade >> log.txt
	pause
	exit /B 0
) ELSE (
	echo %DATE%_%TIME%	Done, version=%version%, do upgrade >> log.txt
)
echo Upgrade firmware ...
echo %DATE%_%TIME%	Upgrade FW ... >> log.txt
START /B /WAIT FwUpdateCmd.exe FWUpdate "%controller%" "Acer_Rayleigh_AR_HR_2C_B1_rev15_W_Ti_1_5_0_SEC1_sign.bin" >> log.txt 2>&1
echo %DATE%_%TIME%	Done, rc=%ERRORLEVEL% >> log.txt
IF %ERRORLEVEL% NEQ 0 (exit /B 1)

echo %DATE%_%TIME%	Show shutdown message >> log.txt
START /WAIT part_2.exe
echo %DATE%_%TIME%	Shutdown >> log.txt
shutdown -f -s -t 3

exit /B 0